Magellan Linux

Contents of /trunk/installer-simple/bin/installer.sh.in

Parent Directory Parent Directory | Revision Log Revision Log


Revision 2443 - (show annotations) (download)
Tue Jan 7 14:50:35 2014 UTC (10 years, 3 months ago) by niro
File size: 18140 byte(s)
-install_system_settings(): use addconfig()
1 #!/bin/bash
2 # $Id$
3 #
4 # Simple Installation Script
5 # merged from alxinstall-ng and mcore-installer
6 #
7 # Niels Rogalla <niro@magellan-linux.de>
8 #
9
10 # ignore the environment
11 LC_ALL=C
12 # include dir
13 INSTALLER_LIBDIR="%LIBDIR%"
14
15 # TOTALLINES=linecount of ${CDIMAGENAME}-tarball -1 !
16 # -> now in images.conf
17 CURRENTLINE=0
18
19 die()
20 {
21 echo "Error: $@"
22 exit 1
23 }
24
25 # load common includes
26 for inc in %SYSCONFDIR%/installer.conf \
27 ${INSTALLER_LIBDIR}/functions/common.sh \
28 ${INSTALLER_LIBDIR}/functions/common-dialogs.sh \
29 ${INSTALLER_LIBDIR}/functions/hwdetection.sh \
30 ${INSTALLER_LIBDIR}/functions/bootloader.sh \
31 ${INSTALLER_LIBDIR}/functions/initrd-tools.sh \
32 ${INSTALLER_LIBDIR}/functions/installer-dialogs.sh
33 do
34 if [ -e ${inc} ]
35 then
36 source "${inc}"
37 else
38 die "'${inc}' not found"
39 fi
40 done
41
42 # TOTALLINES=linecount of ${CDIMAGENAME}-tarball -1 !
43 # -> now in images.conf
44 CDIMAGENAME=""
45 TOTALLINES=""
46 CURRENTLINE=0
47 if [ -e /mnt/cdrom/system/images.conf ]
48 then
49 source /mnt/cdrom/system/images.conf
50 # check if all required variables are set
51 [[ -z ${CDIMAGENAME} ]] && die "CDIMAGENAME is empty in /mnt/cdrom/system/images.conf"
52 [[ -z ${TOTALLINES} ]] && die "TOTALLINES is empty in /mnt/cdrom/system/images.conf"
53 else
54 die "/mnt/cdrom/system/images.conf not found"
55 fi
56
57 ### System/Config Version
58 VERSION="%VERSIONTAG%"
59 TITLE="${DEFAULT_TITLE} - ${VERSION}"
60
61 # some sane defaults
62 CDROOT="${DEFAULT_CDROOT}"
63 INSTALLROOT="${DEFAULT_INSTALLROOT}"
64 KERNELPKG="${DEFAULT_KERNELPKG}"
65 KERNELOPTS="${DEFAULT_KERNELOPTS}"
66 GRUBLEGACYOPTS=""
67 GRUB2OPTS=""
68 FDISKPARTIONBELOW256MB=0
69 SPECIALDEVICE=""
70 FORMFACTOR="${DEFAULT_FORMFACTOR}"
71 FORMAT_FILESYSTEM="${DEFAULT_FILESYSTEM}"
72
73 #################################################
74 # DIALOG BOXEN #
75 #################################################
76
77 trap_exit()
78 {
79 is_mounted --location "${INSTALLROOT}/dev" && umount ${INSTALLROOT}/dev
80 is_mounted --location "${INSTALLROOT}/proc" && umount ${INSTALLROOT}/proc
81 is_mounted --location "${INSTALLROOT}/sys" && umount ${INSTALLROOT}/sys
82 is_mounted --location "${INSTALLROOT}/boot" && umount ${INSTALLROOT}/boot
83 is_mounted --location "${INSTALLROOT}" && umount ${INSTALLROOT}
84
85 echo $"Installation aborted."
86 exit 1
87 }
88
89 dialog_die()
90 {
91 ERROR="$1"
92 RETVAL="$?"
93 dialog_install_failure
94 exit 1
95 }
96
97 dialog_warning()
98 {
99 local retval
100
101 yesnobox $"\Z1 !!! Warning !!! \Zn\n\n\This harddrive will be irreversibly erased.\n\n\Do you want to continue ?"
102 retval=$?
103 if [[ ${retval} -eq 1 ]]
104 then
105 clear
106 echo $"The process was aborted."
107 exit 1
108 fi
109 }
110
111 dialog_setup_hdd_info()
112 {
113 local SHDD="${HDD//\/dev\/}"
114
115 messagebox -h $"[ Harddrive partitioning ]" \
116 $"\nPlease create 1 partition.\n\n\[ \Z3${SHDD}1\Zn ] type: \Z3linux\Zn with the whole diskspace\n\Please mark ${SHDD}1 \Z3bootable\Zn."
117 }
118
119 dialog_setup_hdd_info_auto()
120 {
121 local SHDD="${HDD//\/dev\/}"
122
123 messagebox -h $"[ Harddrive partitioning ]" \
124 $"\Z1Warning!\Zn\n\nAll data on disk [ \Z3${HDD}\Zn ] will be erased!"
125 }
126
127 dialog_setup_system_menu()
128 {
129 local mode
130 local retval
131
132 mode=$(menubox -h $"[ Harddrive partitioning ]" $"\nSelect an installation mode" \
133 $"1:Automatic setup (recommended)" \
134 ":" \
135 $":\Z1Expert modes:\Zn" \
136 $"2:Common IDE-disk (manual setup)")
137 retval=$?
138 [[ ${retval} -eq 1 ]] && return 1
139 if [[ ${retval} -eq 0 ]]
140 then
141 case "${mode}" in
142 "1") run_install_auto ;;
143 "2") run_install_normal ;;
144 "") dialog_setup_system_menu;;
145 esac
146 fi
147 }
148
149 dialog_hardware_detection()
150 {
151 local message
152
153 run_hardware_detection_disks
154
155 message+=$"Harddrives:\n"
156
157 if [[ ! -z ${ALL_DISKS} ]]
158 then
159 for i in ${ALL_DISKS}
160 do
161 message+="\Z3${i}\Zn "
162 done
163 message+="\n"
164 fi
165
166 if [[ ! -z ${ALL_CDROMS} ]]
167 then
168 message+="\n"
169 message+=$"Optical disk drives:\n"
170 for i in ${ALL_CDROMS}
171 do
172 message+="\Z3${i}\Zn"
173 done
174 message+="\n"
175 fi
176
177 # other devices
178 run_hardware_detection
179 case "${SPECIALDEVICE}" in
180 zotac*) message+=$"\n\Z2Zotac device detected.\Zn" ;;
181 rangee) message+=$"\n\Z2Rangee device detected.\Zn" ;;
182 maxdata) message+=$"\n\Z2Maxdata device detected.\Zn" ;;
183 *) message+=$"\n \\ZnCommon device detected.\Zn" ;;
184 esac
185 if [[ ${FORMFACTOR} = laptop ]]
186 then
187 message+=$"\n\ZnFormfactor Laptop, activating 'ondemand' powersaving mode.\Zn"
188 fi
189
190 messagebox -y 15 -h $"Detected hardware:" "${message}"
191 }
192
193 dialog_setup_hdd_partitions_manual()
194 {
195 local i
196 local retval
197
198 if [[ -z ${ALL_DISKS} ]]
199 then
200 dialog_no_harddrive_found
201 exit 1
202 else
203 HDD=$(dialog_select_target_harddrive)
204 retval=$?
205 [[ ${retval} -eq 1 ]] && return 1
206 if [[ ${retval} -eq 0 ]]
207 then
208 dialog_setup_hdd_info
209 setup_hdd_partitions_manual
210 fi
211 fi
212 }
213
214 dialog_setup_hdd_partitions_auto()
215 {
216 local i
217 local retval
218
219 if [[ -z ${ALL_DISKS} ]]
220 then
221 dialog_no_harddrive_found
222 exit 1
223 else
224 HDD=$(dialog_select_target_harddrive)
225 retval=$?
226 [[ ${retval} -eq 1 ]] && return 1
227 if [[ ${retval} -eq 0 ]]
228 then
229 dialog_setup_hdd_info_auto
230 dialog_setup_hdd_create_partitions
231 setup_hdd_partitions_auto
232 fi
233 fi
234 }
235
236 install_meter()
237 {
238 while [[ ${CURRENTLINE} != ${TOTALLINES} ]]
239 do
240 CURRENTLINE=$(grep -c . /tmp/install.log)
241 PERCENT=$(( ${CURRENTLINE} * 100 / ${TOTALLINES}))
242 echo ${PERCENT}
243 sleep 1
244 done
245 rm -f /tmp/install.log
246 return 0
247 }
248
249 dialog_main()
250 {
251 local method=0
252 local retval
253
254 while [[ ${method} -le 2 ]]
255 do
256 method=$(menubox $"Configuration:" \
257 $"1:Install system" \
258 $"2:Show detected harddrives" \
259 $"3:Exit and reboot" \
260 $"4:Exit and drop into a shell")
261 retval=$?
262 [[ ${retval} -eq 1 ]] && exit 1
263 if [[ ${retval} -eq 0 ]]
264 then
265 case ${method} in
266 "1") dialog_setup_system_menu ;;
267 "2") dialog_hardware_detection ;;
268 "3") install_do_reboot ;;
269 "4") /bin/bash --login -i ;;
270 esac
271 fi
272 done
273 }
274
275 #################################################
276 # Install Komandos #
277 #################################################
278 run_hardware_detection()
279 {
280 local hwinfo
281
282 hwinfo="$(hwinfo --bios --storage --pci --gfxcard --sys)"
283
284 ## check for special devices/clients:
285 ## if zotac a zotac and the disk is a removeable device, then add rootdelay to kernelcmd
286 #local removable=0
287 #if [[ ! -z $(echo "${hwinfo}" | grep -i zotac) ]]
288 #then
289 #for i in /sys/block/[hs]d*/removable
290 #do
291 #if [[ $(< ${i}) = 1 ]]
292 #then
293 #removable=1
294 #fi
295 #done
296 ## smartcard = udevadm info -n /dev/sda -a | grep -i 'configuration.*card'
297
298 ## only add this for grub legacy, grub2 detect these settings on its own
299 #export GRUBLEGACYOPTS="rootdelay=8"
300 ## there are to zotac types in the wild, nvidia based gfx and intel
301 #if [[ ! -z $(echo "${hwinfo}" | grep -i nouveau) ]]
302 #then
303 #export SPECIALDEVICE="zotac_nvidia"
304 #else
305 #export SPECIALDEVICE="zotac_intel"
306 #fi
307 #fi
308
309 # check for special devices/clients:
310 # if a rangee and disk ist smaller then 256mb move partion one block further ahead
311 if [[ ! -z $(echo "${hwinfo}" | grep -i CLE266) ]]
312 then
313 # for a rangee always define partion startblock +1
314 export FDISKPARTIONBELOW256MB="1"
315 export SPECIALDEVICE="rangee"
316 export GRUBLEGACYOPTS=""
317 fi
318
319 # check for special devices/clients:
320 # check for maxdata / i810/ i815 Chipsets and disable KMS and use i810fb frambuffer
321 if [[ ! -z $(echo "${hwinfo}" | grep -i i810) ]] || [[ ! -z $(echo "${hwinfo}" | grep -i i815) ]]
322 then
323 export SPECIALDEVICE="maxdata"
324 export GRUBLEGACYOPTS=""
325 fi
326
327 # check for special devices/clients:
328 # check for laptops and activate cpufreq scaling
329 if [[ $(echo "${hwinfo}" | grep 'Formfactor:' | sed 's:.*Formfactor\:\ \"\(.*\)\":\1:') = laptop ]]
330 then
331 export FORMFACTOR="laptop"
332 export KERNELOPTS="${KERNELOPTS} cpufreq.governor=ondemand"
333 fi
334 }
335
336 run_hardware_detection_disks()
337 {
338 local bootdev
339
340 # all disks but exclude ramdisks
341 export ALL_DISKS=$(get_hwinfo disk | sed '/\/dev\/ram[0-9].*/d')
342 # remove the boot device from ALL_DISKS if it was an usbstick
343 if [[ $(grep '[[:space:]]/mnt/cdrom[[:space:]]' /proc/mounts | cut -d' ' -f3) != iso9660 ]]
344 then
345 bootdev="$(grep '[[:space:]]/mnt/cdrom[[:space:]]' /proc/mounts | cut -d' ' -f1 | sed 's:[0-9]::g')"
346 export ALL_DISKS=$(echo "${ALL_DISKS}" | grep -v "${bootdev}")
347 fi
348 export ALL_CDROMS="$(get_hwinfo cdrom)"
349 }
350
351 hdd_size_below_256mb()
352 {
353 local hdd="$1"
354 local size
355 local retval
356 [[ -z ${hdd} ]] && dialog_die "Error: get_hdd_size() no \$hdd given!"
357
358 size=$(fdisk -l ${hdd} | grep "Disk.*${hdd}" | sed 's:.*,\ \(.*\)\ byte.*:\1:')
359 if [[ ${size} -le 257000000 ]]
360 then
361 retval="0"
362 else
363 retval="1"
364 fi
365
366 return "${retval}"
367 }
368
369 setup_hdd_partitions_auto()
370 {
371 ROOTHDD="${HDD}1"
372
373 # sanity check - should not happen
374 if is_mounted --device "${ROOTHDD}"
375 then
376 echo "partition: device ${ROOTHDD} is already mounted, umount it" >&2
377 umount "${ROOTHDD}"
378 fi
379
380 # run this only if FDISKPARTITIONBELOW256MB is not already 1
381 if [[ ${FDISKPARTIONBELOW256MB} != 1 ]]
382 then
383 if hdd_size_below_256mb ${HDD}
384 then
385 FDISKPARTIONBELOW256MB=1
386 else
387 FDISKPARTIONBELOW256MB=0
388 fi
389 fi
390
391 ## delete disk
392 dd if=/dev/zero of=${HDD} count=1 &> /dev/null || dialog_die
393
394 if [[ ${FDISKPARTIONBELOW256MB} = 1 ]]
395 then
396 ## setup one bootable partition
397 #1. n= new disk
398 #2. p= primary disk
399 #3. 1= first partition
400 #4. 2= default sector start // small disk needs more space for grub2 mbr sector
401 #5. ''= defaul sector end
402 #6. a= bootable flag
403 #7. 1= boot flag for partition 1
404 #8. w= write/quit
405 fdisk ${HDD} &> /dev/null << EOF
406 n
407 p
408 1
409 2
410
411 a
412 1
413 w
414 EOF
415 else
416 ## setup one bootable partition
417 #1. n= new disk
418 #2. p= primary disk
419 #3. 1= first partition
420 #4. ''= default sector start
421 #5. ''= defaul sector end
422 #6. a= bootable flag
423 #7. 1= boot flag for partition 1
424 #8. w= write/quit
425 fdisk ${HDD} &> /dev/null << EOF
426 n
427 p
428 1
429
430
431 a
432 1
433 w
434 EOF
435 fi
436 }
437
438 setup_hdd_partitions_manual()
439 {
440 ROOTHDD="${HDD}1"
441 SWAPHDD=""
442 BOOTHDD=""
443 cfdisk ${HDD} || dialog_die
444 }
445
446 setup_hdd_format()
447 {
448 # sanity check - should not happen
449 if is_mounted --device "${ROOTHDD}"
450 then
451 echo "format: device ${ROOTHDD} is already mounted, umount it" >&2
452 umount "${ROOTHDD}"
453 fi
454
455 mkfs."${FORMAT_FILESYSTEM}" -q "${ROOTHDD}" || dialog_die
456 }
457
458 install_mount_rootfs()
459 {
460 is_mounted --location "${INSTALLROOT}" || mount "${ROOTHDD}" "${INSTALLROOT}"
461 install -d ${INSTALLROOT}/boot || dialog_die
462 }
463
464 install_system_image()
465 {
466 pushd ${INSTALLROOT} > /dev/null
467 tar xvjpf ${CDROOT}/system/${CDIMAGENAME} -C ${INSTALLROOT}
468 popd > /dev/null
469 }
470
471 install_bootsector_chroot()
472 {
473 local my_roothdd
474 local grubconf=${INSTALLROOT}/boot/grub/grub.conf
475 local grub2conf=/boot/grub/grub.cfg
476
477 # check for grub2
478 if [[ -f ${INSTALLROOT}/sbin/grub-mkconfig ]]
479 then
480 # needed by grub-mkconfig on the first run
481 if [[ ! -f ${INSTALLROOT}/boot/grub/video.lst ]]
482 then
483 install -m0644 ${INSTALLROOT}/lib/grub/*/video.lst ${INSTALLROOT}/boot/grub/video.lst || dialog_die
484 fi
485
486 # set kernelopts
487 if [[ -f ${INSTALLROOT}/etc/conf.d/grub ]]
488 then
489 sed -i "s:^\(export GRUB_CMDLINE_LINUX_DEFAULT=\).*:\1\"${KERNELOPTS}\":" ${INSTALLROOT}/etc/conf.d/grub || dialog_die
490 else
491 echo "export GRUB_CMDLINE_LINUX_DEFAULT=\"${KERNELOPTS}\"" > ${INSTALLROOT}/etc/conf.d/grub || dialog_die
492 fi
493 echo 'grub-mkdevicemap' > ${INSTALLROOT}/root/.installrc || dialog_die
494 echo "LC_ALL=C grub-mkconfig -o ${grub2conf} &> /dev/null" >> ${INSTALLROOT}/root/.installrc || dialog_die
495 echo "grub-install --no-floppy ${HDD} &> /dev/null" >> ${INSTALLROOT}/root/.installrc || dialog_die
496 echo "exit 0" >> ${INSTALLROOT}/root/.installrc || dialog_die
497
498 # grub-legacy
499 else
500 ### grubconf schreiben
501 source ${INSTALLROOT}/boot/kernelversion
502
503 #for alx only
504 if [ -e ${INSTALLROOT}/etc/alx_version ]
505 then
506 OLD_ALXVER="${ALXVER}"
507 source ${INSTALLROOT}/etc/alx_version
508 KRNVER="ALX-${ALXVER}"
509 ALXVER="${OLD_ALXVER}"
510 fi
511
512 [[ -z ${KRNVER} ]] && KRNVER="AutoSta_LX"
513 [[ -z ${KRNINITRD} ]] && KRNINITRD="initrd"
514 [[ -z ${KRNIMG} ]] && KRNIMG="vmlinuz"
515
516 # uuid support
517 my_roothdd="UUID=$(get_uuid ${ROOTHDD})"
518
519 : > ${grubconf} || dialog_die
520 echo "default 0" >> ${grubconf} || dialog_die
521 echo "timeout 3" >> ${grubconf} || dialog_die
522 # using current root password
523 echo "password --md5 $(cat ${INSTALLROOT}/etc/shadow | grep root | cut -d: -f2)" >> ${grubconf} || dialog_die
524
525 echo >> ${grubconf} || dialog_die
526 echo "# normal boot" >> ${grubconf} || dialog_die
527 echo "title ${KRNVER}" >> ${grubconf} || dialog_die
528 echo "root (hd0,0)" >> ${grubconf} || dialog_die
529 echo "kernel /boot/${KRNIMG} root=${my_roothdd} ${KERNELOPTS} ${GRUBLEGACYOPTS}" >> ${grubconf} || dialog_die
530 if is_initrd_supported
531 then
532 echo "initrd /boot/${KRNINITRD}" >> ${grubconf} || dialog_die
533 fi
534
535 echo >> ${grubconf} || dialog_die
536 echo "# admin boot" >> ${grubconf} || dialog_die
537 echo "title ${KRNVER} - Re-run hardware-detection" >> ${grubconf} || dialog_die
538 echo "lock" >> ${grubconf} || dialog_die
539 echo "root (hd0,0)" >> ${grubconf} || dialog_die
540 echo "kernel /boot/${KRNIMG} root=${my_roothdd} ${KERNELOPTS} ${GRUBLEGACYOPTS} hardware-auto-detection" >> ${grubconf} || dialog_die
541 if is_initrd_supported
542 then
543 echo "initrd /boot/${KRNINITRD}" >> ${grubconf} || dialog_die
544 fi
545
546 echo >> ${grubconf} || dialog_die
547 echo "title ${KRNVER} - Reset *all* local settings" >> ${grubconf} || dialog_die
548 echo "lock" >> ${grubconf} || dialog_die
549 echo "root (hd0,0)" >> ${grubconf} || dialog_die
550 echo "kernel /boot/${KRNIMG} root=${my_roothdd} ${KERNELOPTS} ${GRUBLEGACYOPTS} alx-reset-settings" >> ${grubconf} || dialog_die
551 if is_initrd_supported
552 then
553 echo "initrd /boot/${KRNINITRD}" >> ${grubconf} || dialog_die
554 fi
555
556 # bootsector schreiben chrooted schreiben (lfs/magellan)
557 cat > ${INSTALLROOT}/root/.installrc << CHROOTEOF
558 /usr/sbin/grub --no-floppy --batch << "EOF" 1> /dev/null 2> /dev/null
559 root (hd0,0)
560 setup (hd0)
561 quit
562 EOF
563 exit 0
564 CHROOTEOF
565 fi
566
567 # run installrc
568 chrooted /bin/bash --rcfile /root/.installrc -i
569 rm ${INSTALLROOT}/root/.installrc
570 }
571
572 install_initrd_chroot()
573 {
574 # only generate initrds if the cmd exists
575 is_initrd_supported || return 0
576
577 DISKMODS="sd_mod"
578 OLDPATAMODS="amd74xx piix sis5513 via82cxxx"
579 PATAMODS="ata_piix pata_amd pata_mpiix pata_oldpiix pata_sis pata_via"
580 SATAMODS="sata_via sata_sis sata_nv"
581 DRMMODS="i915 mga nouveau r128 radeon savage sis tdfx ttm via"
582 OTHERMODS=""
583 case ${SPECIALDEVICE} in
584 zotac_intel) FBMODS=""; DRMMODS="i915" ;;
585 zotac_nvidia) FBMODS=""; DRMMODS="nouveau" ;;
586 rangee) FBMODS="" ;; ## fallback to vesafb, viafb does not run on all CLE266 boards
587 # not working with kms enabled drivers -> segfaults
588 #maxdata) FBMODS="i810fb" ;; ## check for maxdata / i810/ i815 Chipsets and disable KMS and use i810fb frambuffer
589 maxdata) FBMODS="" ;;
590 *) FBMODS="uvesafb" ;;
591 esac
592
593 if [[ ${FORMFACTOR} = laptop ]]
594 then
595 OTHERMODS="acpi-cpufreq cpufreq_ondemand cpufreq_conservative cpufreq_powersave"
596 fi
597
598 # install an appropriate uvesafb.conf
599 install -d ${INSTALLROOT}/etc/modprobe.d || dialog_die
600 echo "options uvesafb mode_option=1024x768-32@60 scroll=ywrap" > ${INSTALLROOT}/etc/modprobe.d/uvesafb.conf || dialog_die
601
602 # install an appropriate viafb.conf
603 echo "options viafb viafb_mode=1024x768 viafb_refresh=60" > ${INSTALLROOT}/etc/modprobe.d/viafb.conf || dialog_die
604
605 # install an appropriate i810fb.conf
606 echo "options i810fb xres=1024 yres=768 bpp=16 mtrr=1 hsync1=30 hsync2=62 vsync1=30 vsync2=60" > ${INSTALLROOT}/etc/modprobe.d/i810fb.conf || dialog_die
607
608 cat > ${INSTALLROOT}/root/.installrc << CHROOTEOF
609 echo "MODULES=\"${FORMAT_FILESYSTEM} ${DISKMODS} ${OLDATAMODS} ${PATAMODS} ${SATAMODS} ${DRMMODS} ${FBMODS} ${OTHERMODS}\"" > /etc/conf.d/mkinitrd
610 mkinitrd -f /boot/$(readlink /boot/initrd) $(readlink /boot/vmlinuz | sed "s:kernel-::g") > /dev/null
611 exit 0
612 CHROOTEOF
613
614 # run installrc
615 chrooted /bin/bash --rcfile /root/.installrc -i
616 rm ${INSTALLROOT}/root/.installrc
617 }
618
619 install_system_settings()
620 {
621 local CONFIG
622
623 # write fstab
624 CONFIG="${INSTALLROOT}/etc/fstab"
625 clearconfig
626 addconfig -e "UUID=$(get_uuid ${ROOTHDD})\t/\t${FORMAT_FILESYSTEM}\tnoatime,noauto\t1 1"
627 addconfig -e "proc\t/proc\tproc\tdefaults\t0 0"
628 addconfig -e "shm\t/dev/shm\ttmpfs\tdefaults\t0 0"
629
630 # install network config skeleton
631 CONFIG="${INSTALLROOT}/etc/conf.d/net.eth0"
632 clearconfig
633 addconfig 'ONBOOT="yes"'
634 addconfig 'NETWORKING="dhcp"'
635
636 # intel framebuffer quirk
637 if [ -e ${INSTALLROOT}/etc/splash/splash.conf ]
638 then
639 if [ -e /proc/fb ]
640 then
641 if [[ ! -z $(grep 'inteldrmfb' /proc/fb) ]]
642 then
643 fbdev=$(grep 'inteldrmfb' /proc/fb | sed 's:\([0-9]\).*:\1:')
644 if [[ ${fbdev} != 0 ]]
645 then
646 sed -i "s:^\(SPLASH_DEV=\).*:\1\"/dev/fb${fbdev}\":" ${INSTALLROOT}/etc/splash/splash.conf || dialog_die
647 fi
648 fi
649 fi
650 fi
651 }
652
653 install_umount_rootfs()
654 {
655 is_mounted --location ${INSTALLROOT}/boot && umount ${INSTALLROOT}/boot
656 is_mounted --location ${INSTALLROOT} && umount ${INSTALLROOT}
657 }
658
659 install_do_reboot()
660 {
661 reboot
662 }
663
664 #################################################
665 # Install Ablauf Scripte #
666 #################################################
667
668 run_install_normal()
669 {
670 dialog_hardware_detection
671
672 dialog_setup_hdd_partitions_manual
673 dialog_setup_hdd_format
674 setup_hdd_format > /dev/null
675 install_mount_rootfs
676 (install_system_image > /tmp/install.log) 2> /tmp/install_errors.log | install_meter | dialog_install_system_image
677
678 dialog_install_settings
679 sleep 1
680 install_system_settings
681 if is_initrd_supported
682 then
683 dialog_install_initrd
684 initrd_config
685 initrd_install
686 fi
687
688 dialog_install_bootsector
689 bootloader_config
690 bootloader_install
691
692 install_umount_rootfs
693 dialog_install_successful
694 }
695
696 run_install_auto()
697 {
698 dialog_hardware_detection
699
700 dialog_setup_hdd_partitions_auto
701 dialog_setup_hdd_format
702 setup_hdd_format > /dev/null
703 install_mount_rootfs
704 (install_system_image > /tmp/install.log) 2> /tmp/install_errors.log | install_meter | dialog_install_system_image
705
706 dialog_install_settings
707 sleep 1
708 install_system_settings
709 if is_initrd_supported
710 then
711 dialog_install_initrd
712 initrd_config
713 initrd_install
714 fi
715
716 dialog_install_bootsector
717 bootloader_config
718 bootloader_install
719
720 install_umount_rootfs
721 dialog_install_successful
722 }
723
724 # set some proper traps
725 trap "trap_exit" SIGINT SIGQUIT
726
727 dialog_main
728
729 exit 0